class BrushTool extends DrawingTool
{
  public final int ID = 3;

  private PShape _shape = null;

  public BrushTool(int _x, int _y, int _w, int _h)
  {
    super (_x, _y, _w, _h);
      baseSize = 30.0;
      minDist = 2.0;
  }

  public void loadBrush(String shapeFile)
  {
    _shape = loadShape(shapeFile);
    // use Processing's style
    _shape.disableStyle();
  }

  // this is where the magic happens!
  protected void _draw(PGraphics pg, float pressure) 
  {
    pg.noStroke();
    pg.fill(fillColor);
    pg.pushMatrix();
    pg.translate(mouseTX,mouseTY);
    shapeMode(CENTER);

    float s = baseSize*pressure;
    pg.rotate(angle);
    pg.shape(_shape, 0,0, s,s);
    pg.popMatrix();
  }
}
