class CircleTool extends DrawingTool
{
  public final int ID = 1;

  public CircleTool(int _x, int _y, int _w, int _h)
  {
    super (_x, _y, _w, _h);
    baseSize = 30.0;
    minDist = 2.0;
  }


  // this is where the magic happens!
  protected void _draw(PGraphics pg, float pressure) 
  {
    pg.ellipseMode(CENTER);
    pg.noStroke();
    pg.fill(fillColor);
    pg.pushMatrix();
    pg.translate(mouseTX,mouseTY);

    float s = baseSize*pressure;

    pg.ellipse(0,0, s,s);
    pg.popMatrix();
  }
}

