class LineTool extends DrawingTool
{
  public final int ID = 0;

  public LineTool(int _x, int _y, int _w, int _h)
  {
    super (_x, _y, _w, _h);
    baseSize = 30.0;
    minDist = 0.0;
    maxDist = 80.0;
  }

  // this is where the magic happens!
  protected void _draw(PGraphics pg, float pressure) 
  {
    pg.noFill();
    pg.stroke(strokeColor);

    
    if (currentDistance > maxDist)
    {
      prevMouseX = mouseTX;
      prevMouseY = mouseTY;
    }
    else
    {
      pg.line(prevMouseX,prevMouseY, mouseTX,mouseTY);
      
      float s = baseSize*pressure+1.0;
      pg.strokeWeight(s);
    }
  }
  
  public void setColor(int c)
  {
    this.strokeColor = c;
  }
}

