boolean saveFramesToMovie()
{
  
  boolean success = false;
  
 	// here's where the magic happens - must install Macports and then ffmpeg
    // this next bit runs an external program (ffmpeg) to mash all the image files together into a single movie
    try {

      String cmdline = "/opt/local/bin/ffmpeg -i " + audioFileLoadPath +  " -r " + fps + " -b 1800000 -i "+ outFileFolder  + "/" + outFileNamePrefix + "" + fileNameSequence + "_%07d.tiff "
        + outFileFolder + "/" + outFileNamePrefix + "" + fileNameSequence + ".mp4";

      if (debug) println("RUNNING COMMAND: " +  cmdline);

      String s = null;

      Process p = Runtime.getRuntime().exec(cmdline); 

      // get its output (your input) stream 

      BufferedReader stdInput = new BufferedReader(new 
        InputStreamReader(p.getInputStream()));

      BufferedReader stdError = new BufferedReader(new 
        InputStreamReader(p.getErrorStream()));
      
      // wait for it to finish
      p.waitFor();

      // read the output from the command
      if (debug) println("Here is the standard output of the command:\n");
      while ((s = stdInput.readLine()) != null) 
      {
        if (debug) println(s);
      }

      // read any errors from the attempted command
      if (debug) println("Here is the standard error of the command (if any):\n");
      while ((s = stdError.readLine()) != null) 
      {
        if (debug) println(s);
      }
      
      // test if we were successful
      if (p.exitValue() != 0)
      {
        if (debug) println("ERROR: MOVIE NOT WRITTEN!"); 
      }
      else
      {
        //------- MOVIE WAS SUCCESSFULY CREATED
        //------------------------------------------------------------------------------------------
        success = true;
      }
      
    } 
    catch (Exception e)
    { 
      // crap, we got an error! quit...
      if (debug) println(e); 
    }
    
    return success;
}
