class SquareTool extends DrawingTool
{
  public final int ID = 2;

  public SquareTool(int _x, int _y, int _w, int _h)
  {
    super (_x, _y, _w, _h);
    baseSize = 30.0;
    minDist = 2.0;
  }


  // this is where the magic happens!
  protected void _draw(PGraphics pg, float pressure) 
  {
    pg.rectMode(CENTER);
    pg.noStroke();
    pg.fill(fillColor);
    pg.pushMatrix();
    pg.translate(mouseTX,mouseTY);

    float s = baseSize*pressure;
    pg.rotate(angle);
    pg.rect(0,0, s,s);
    pg.popMatrix();
  }
}

